<?php

namespace Drupal\openstack\Entity;

use Drupal\aws_cloud\Entity\Ec2\AwsCloudViewBuilder;

/**
 * Provides the quota view builders.
 */
class OpenStackQuotaViewBuilder extends AwsCloudViewBuilder {

  /**
   * {@inheritdoc}
   */
  protected function getFieldsetDefs(): array {
    return [
      [
        'name' => 'quota',
        'title' => $this->t('Quota'),
        'open' => TRUE,
        'fields' => [
          'name',
          'created',
        ],
      ],
      [
        'name' => 'quota_compute',
        'title' => $this->t('Compute'),
        'open' => TRUE,
        'fields' => [
          'instances',
          'cores',
          'ram',
          'metadata_items',
          'key_pairs',
          'server_groups',
          'server_group_members',
          'injected_files',
          'injected_file_content_bytes',
          'injected_file_path_bytes',
        ],
      ],
      [
        'name' => 'quota_volume',
        'title' => $this->t('Volume'),
        'open' => TRUE,
        'fields' => [
          'volumes',
          'snapshots',
          'gigabytes',
        ],
      ],
      [
        'name' => 'quota_network',
        'title' => $this->t('Network'),
        'open' => TRUE,
        'fields' => [
          'network',
          'subnet',
          'port',
          'router',
          'floatingip',
          'security_group',
          'security_group_rule',
        ],
      ],
      [
        'name' => 'others',
        'title' => $this->t('Others'),
        'open' => FALSE,
        'fields' => [
          'cloud_context',
          'uid',
        ],
      ],
    ];
  }

}
