@minimal @ci_job
Feature: Create, read, update and delete a network interfaces for OpenStack as "Authenticated User"

  @api
  Scenario: Create a network interface
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/network_interface/add"
    And I should see the heading "Add OpenStack network interface"
    And I enter "{{ network_interface_name_operate }}" for "Name"
    And I press "Save"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/network_interface"
    And I should see the success message "has been created"
    And I should see neither error nor warning messages
    And I should see the link "{{ network_interface_name_operate }}" in the table

  @api
  Scenario: Read the network interface
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/network_interface"
    And I click "Refresh"
    And I should see the link "{{ network_interface_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ network_interface_name_operate }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/network_interface/"
    And I should see "{{ network_interface_name_operate }}"
    And I should see "{{ status }}"
    And I should see neither error nor warning messages
    And I should see "{{ drupal_user_name }}" in the "Authored by"

  @api
  Scenario: Update the network interface
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/network_interface"
    And I click "Refresh"
    And I should see the link "{{ network_interface_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ network_interface_name_operate }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/network_interface/"
    And I click "Edit"
    And the url should match "/edit"
    And I enter "{{ description }}" for "Description"
    And I press "Save"
    Then I should see the success message "has been update"
    And I should see neither error nor warning messages
    And I should see the link "{{ network_interface_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ network_interface_name_operate }}"
    And I should see "{{ network_interface_name_operate }}"
    And I should see "{{ description }}"
    And I should see neither error nor warning messages
    And I should see "{{ drupal_user_name }}" in the "Authored by"

  @api
  Scenario: Delete the network interface
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/network_interface"
    And I click "Refresh"
    And I should see the link "{{ network_interface_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ network_interface_name_operate }}"
    And the url should match "/clouds/openstack/{{ cloud_context }}/network_interface/"
    And I click "Delete"
    Then the url should match "/delete"
    And I press "Delete"
    Then I should be on "/clouds/openstack/{{ cloud_context }}/network_interface"
    And I should see the success message "has been deleted"
    And I should see neither error nor warning messages
    And I click "Refresh"
    And I should not see the link "{{ network_interface_name_operate }}"
