@minimal @ci_job
Feature: Create, read, update and delete a floating IP for OpenStack as "Authenticated User"

  @api
  Scenario: Create a floating IP
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/floating_ip/add"
    And I should see the heading "Add OpenStack Floating IP"
    And I enter "{{ floating_ip_name_operate }}" for "Name"
    And I select "{{ floating_network_id }}" from "Floating network ID"
    And I press "Save"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/floating_ip"
    And I should see the success message "has been created"
    And I should see neither error nor warning messages
    And I should see the link "{{ floating_ip_name_operate }}" in the table

  @api
  Scenario: Read the floating IP
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/floating_ip"
    And I click "Refresh"
    And I should see the link "{{ floating_ip_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ floating_ip_name_operate }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/floating_ip/"
    And I should see "{{ floating_ip_name_operate }}" in the "page_header"
    And I should see "{{ drupal_user_name }}" in the "Authored by"

  @api
  Scenario: Update the floating IP
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/floating_ip"
    And I click "Refresh"
    And I should see the link "{{ floating_ip_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ floating_ip_name_operate }}"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/floating_ip/"
    And I click "Edit"
    And the url should match "/edit"
    And I enter "{{ floating_ip_name_operate_updated }}" for "Name"
    And I press "Save"
    Then I should see the success message "has been updated"
    And I should see neither error nor warning messages
    And I should see the link "{{ floating_ip_name_operate_updated }}" in the table

  @api
  Scenario: Delete the floating ip
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/floating_ip"
    And I click "Refresh"
    And I should see the link "{{ floating_ip_name_operate_updated }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ floating_ip_name_operate_updated }}"
    And the url should match "/clouds/openstack/{{ cloud_context }}/floating_ip/"
    And I click "Delete"
    Then the url should match "/delete"
    And I press "Delete"
    Then I should be on "/clouds/openstack/{{ cloud_context }}/floating_ip"
    And I should see the success message "has been deleted"
    And I should see neither error nor warning messages
    And I click "Refresh"
    And I should not see the link "{{ floating_ip_name_operate_updated }}"
