@minimal @ci_job
Feature: Create, read, update and delete a router for OpenStack as "Authenticated User"

  @api
  Scenario: Create a router
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/router/add"
    And I should see the heading "Add OpenStack router"
    And I enter "{{ router_name_operate }}" for "Name"
    # And I select "{{ availability_zone }}" from "Availability Zone"
    And I press "Save"
    Then the url should match "/clouds/openstack/{{ cloud_context }}/router"
    And I should see the success message "has been created"
    And I should see neither error nor warning messages
    And I should see the link "{{ router_name_operate }}" in the table
    And I should see "ACTIVE" in the {{ router_name_operate }}" row

  @api
  Scenario: Delete the router
    Given I am logged in as user "{{ drupal_user_name }}"
    When I visit "/clouds/openstack/{{ cloud_context }}/router"
    And I click "Refresh"
    And I should see the link "{{ router_name_operate }}"
    And I wait {{ wait }} milliseconds
    And I click "{{ router_name_operate }}"
    And the url should match "/clouds/openstack/{{ cloud_context }}/router/"
    And I click "Delete"
    Then the url should match "/delete"
    And I press "Delete"
    Then I should be on "/clouds/openstack/{{ cloud_context }}/router"
    And I should see the success message "has been deleted"
    And I should see neither error nor warning messages
    And I click "Refresh"
    And I should not see the link "{{ router_name_operate }}"
